<?php //#################################################################################
/*############################# sContent-Plugin  ########################################
| copyright: 	Markus Vetter 				| This version: V.0.22		|
| email:	info@mv-web-design.de 			| 		24.07.2008	|
| home:		www.mv-web-design.de/?CMSimple/		|		index.php	|
-----------------------------------------------------------------------------------------
V.0.01 - 25.05.2007: release-Candidate No.1.

V.0.10 - 28.05.2007: release-Candidate No.2.
  New Features 	- Included: Check of all criterias (time/date/....)
  Just Open	- Admin-Section
  
V.0.20 - 30.05.2007: release-Candidate No.3.
  New Features 	- Included: Check of all criterias (time/date/....)
  		- Admin-Section: Edit Control-Files
  		- Date will be check if correct. If not: returns an error and set date now()
  Just Open	- Admin-Section: Image-Upload 
		- Admin-Section: Content-Files-View/Upload 
		- Admin-Section: Create new Control-Files 

V.0.21 - 11.07.2007: 
  New Features 	- Fixed some bugfixes in Admin-Section (Some fields become not correctly saved...)
  		- JS-Calendar included. (JS-Calendar 1.0 from http://www.bazon.net/mishoo/) for easier 
  		  selection of date/time.
  		- Upload-Function corrected.
  Just Open	- Admin-Section: Image-Upload 
		- Admin-Section: Content-Files-View/Upload 
		- Admin-Section: Create new Control-Files 

V.0.22 - 24.07.2008: 
  New Features 	- Bugfix: used unsupported function array_combine() (PHP5-only)
  		- renaming of included functions from .inc to .inc.php for security reasons.
  Just Open	- Admin-Section: Image-Upload 
		- Admin-Section: Content-Files-View/Upload 
		- Admin-Section: Create new Control-Files 
-----------------------------------------------------------------------------------------
Listing of used variables and functions/classes:

Global Variables:
-----------------
$su			: Titel of the (CMSimple-)Document
$sl			: Language which is selected in CMSimple
$tx			: array with CMSimple-Language-text
$plugin_cf		: array with plugin-Configuration
$plugin_tx		: array with plugin-Language-text
$pth			: path of CMSimple
$plugin			: name of plugin (=name of directory of plugin-> must be the same!!)

Plugin Variables:
-----------------
$scontent_version	: version of this Script (will be written in new controlfiles)
$mvwd_new_file_content	: complete header which will be written in first line of each controlfile
$list_parameters	: parameters, which will be read from controlfile (array)

Functions:
----------
scontent()		: Main-Function. Returns scheduled content to CMSimple
scontent_check_period()	: Checks if it fulfilles criterias of time/date. Returns content if valid
scontent_read_content_file() : Reads content-File which includes all criterias and name of content-file
-----------------------------------------------------------------------------------------
/*#######################################################################################
 Format-Info:
 --------------------------------------------------------------------------------------
 Name		  Description			Type		NULL?	Example
 --------------------------------------------------------------------------------------
 title		= Name of Scheduled Content 	(STRING)	no	Test-Scheduler
 active		= Is this Scheduler active? 	(BOOL)		no	true
 active_from	= From when active?		(TIMESTAMP)	no	1180129201 
 active_to	= Until when active?		(TIMESTAMP)	no	1180129550 
 year		= In which year active?		(STRING)	yes	2007
 month		= In which month active?	(STRING)	yes	5|6|7
 day		= On which day active?		(STRING)	yes	1|8|15|22|29
 time_from	= From which hour active?	(STRING)	yes	18:30
 time_to	= Until which hour active?	(STRING)	yes	19:45
 weekday	= On which day(s) active?	(STRING(S))	yes	mo|fr|so
 timestamp	= Time of creation 		(TIMESTAMP)	no	1180129201 
 file		= Name of file to present	(STRING)	no	example.htm
 --------------------------------------------------------------------------------------
 Note:
 The fields year/month/day/weekday must not be set. 
 - If no one of these fields is set, content will be shown all the time, 
   as it is configured in active_from/active_to.
 - If one of the fields is set, content will only be shown on times, the criterias
   are fulfilled.
   1. Example: year:2007, weekday:mo|mi.
      Content will be shown in year 2007 on each Monday and Wednesday 0-24h.
   2. Example: day:1|2|3|4, time_from:7:00, time_to:12:00.
      Content will be shown all the year on the first four days in each month
      from 7 a'clock till 12 a'clock.
 - time_constants in PHP is set by setlocale() to Germany. Hope this is functional in
   all countries and under all conditions. Tests by anyone?
#######################################################################################*/
/*#####################################################################################*/
include 'include.inc.php';
$scontent_version='scontent_V.0.22';  //### Version: needed in new files!!

//### scontent main-Function  ##########################################################/
function scontent($content_nr) 
{ global $pth, $plugin, $plugin_pth, $upload_pth, $plugin_cf, $plugin_tx;
  global $scontent_version, $mvwd_new_file_content;
  $rt='';
  $rt_start_tag='';
  $rt_end_tag='';
  $et_start_tag='';
  $et_end_tag='';
  $mvwd_new_file_content=$scontent_version.';admin;true;Titel;;;;;;;;';
  $list_parameters=array('title', 'active', 'file', 'active_from', 'active_to', 'time_from', 'time_to', 'weekday', 'day', 'month', 'year', 'timestamp');  $plugin=basename(dirname(__FILE__),"/");
  $plugin_pth=$pth['folder']['plugins'].$plugin;
  $upload_pth=$plugin_pth.'/upload/';
  $content_array = scontent_read_file($content_nr, $list_parameters);
  if($content_array[0]['file']=='true' OR $content_array[0]['file']=='active') 
  { array_shift($content_array);
    $classname=($plugin_cf['scontent']['encapsulate_div_classname'])?' class="'.$plugin_cf['scontent']['encapsulate_div_classname'].'"':' class="scontent"';
    if ($plugin_cf['scontent']['encapsulate_in_div']=='true') 
    { if ($plugin_cf['scontent']['encapsulate_in_one_div']=='true') 
      { $rt_start_tag='<div'.$classname.'>'; $rt_end_tag='</div>'; }
      else 
      { $et_start_tag='<div'.$classname.'>'; $et_end_tag='</div>'; } }
    foreach($content_array AS $key => $value) { $rt.=scontent_check_period($et_start_tag,$value,$et_end_tag); } }
return $rt_start_tag.$rt.$rt_end_tag;
}
//### END: scontent main-Function  #####################################################/
//### scontent_check_period  ###########################################################/
function scontent_check_period($rt_start_tag='',$content_array='',$rt_end_tag='')
{ global $plugin_pth;
  $rt='';
  if(!$content_array) { return false; }
  setlocale (LC_ALL, 'deu');
  $now=time();
  $weekday_array=explode("|", $content_array['weekday']);
  $day_array=explode("|", $content_array['day']);
  $month_array=explode("|", $content_array['month']);
  $year_array=explode("|", $content_array['year']);
  $time_from=str_replace(":", "", $content_array['time_from']);
  $time_to=str_replace(":", "", $content_array['time_to']);
  $time_now=strftime('%H').strftime('%M').strftime('%S');
/*   echo('Times: '.$now.' - '); //now
   echo(strftime('%a - ')); //WoTag
   echo(strftime('%d - ')); //TagNr
   echo(strftime('%m - ')); //MonatNr
   echo(strftime('%Y - ')); //Jahr
   echo(strftime('%H - ')); //Stunde
   echo(strftime('%M - ')); //Minute     
   echo(strftime('%S')); //Sekunde    */
  if 
  ( $content_array['active']=='true' OR $content_array['active']=='active' AND  //### this content active?
    ( $content_array['active_from']<=$now AND $content_array['active_to']>=$now ) AND //### in this period active? 
    ( $content_array['year']=='' OR in_array(strftime('%Y'), $year_array)) AND //### in this year active? 
    ( $content_array['month']=='' OR in_array(strftime('%m'), $month_array)) AND //### in this month active? 
    ( $content_array['day']=='' OR in_array(strftime('%d'), $day_array)) AND //### on this day active? 
    ( $content_array['weekday']=='' OR in_array(strtolower(strftime('%a')), $weekday_array)) AND //### on this weekday active? 
    ( $time_from=='' OR $time_now>=$time_from) AND //### from this hour/minute active? 
    ( $time_to=='' OR $time_now<=$time_to) //### to this hour/minute active? 
  )
  { $rt=$rt_start_tag.scontent_read_content_file(rtrim($content_array['file'])).$rt_end_tag; }
return $rt;
}
//### END: scontent_check_period  ######################################################/
//### scontent_read_content_file  ######################################################/
function scontent_read_content_file($file_name)
{ global $plugin_pth, $upload_pth;
  $file_name=$upload_pth.$file_name;
  if(is_file($file_name))
  { $handle = fopen($file_name, "rb");
    $content = fread($handle, filesize($file_name));
    fclose ($handle); }
return $content;
}
//### END: scontent_read_content_file  #################################################/
?>